	org $0600

HIRES			equ $EC33
RANDOM_SEQUENCE	equ $D000
PLAYER_SHAPE	equ 0
BIG_ptr_shape	equ 21
QUEUE_SIZE		equ 8
NB_QUEUES		equ 10
MAX_ALIENS		equ QUEUE_SIZE*NB_QUEUES
PATTERN_VIDE	equ $40
PATTERN_BULLET	equ $48
PATTERN_ALIEN	equ $55
PAPER_COLOR		equ $026B
INK_COLOR		equ $026C
SHOOT			equ $FAB5
EXPLODE			equ $FACB
KEY_CLICK1		equ $FB14
KEY_CLICK2		equ $FB2A

KBD_STATUS		equ $0208
KBD_CTRL_STATUS	equ $0209
KBD_RIGHT		equ $BC
KBD_LEFT		equ $AC
KBD_J			equ $81
KBD_K			equ $83
KBD_SPACE		equ $84
NO_KEY		equ $38
KBD_COL_SCAN	equ $F561

KBD_ASCII		equ $02DF
GET_KEY		equ $023B
KBD_REPEAT1		equ $024E
KBD_REPEAT2		equ $024F
ASCII_RIGHT		equ $09
ASCII_LEFT		equ $08
ASCII_SPACE		equ $20

TOP_LINE_ADDR	equ $A000
BOBINE_FIRST_ADDR	equ $A500
BOBINE_LAST_ADDR	equ $AA00
NEAR_BOTTOM_LINE	equ $BD00
BOTTOM_LINE_ADDR	equ $BE00
TEXT_LINES		equ $BF68
TEXT_LINE1		equ TEXT_LINES
TEXT_LINE2		equ TEXT_LINES+40
TEXT_LINE3		equ TEXT_LINES+80
GAME_OVER_OFFSET	equ 13
SCORE_OFFSET	equ 40+4
lives			equ TEXT_LINES+SCORE_OFFSET+7
score			equ TEXT_LINES+SCORE_OFFSET+15
wave			equ TEXT_LINES+SCORE_OFFSET+29

;***************************************************
; variables page zro

			; aprs HIRES, $0269 (position sur la ligne) vaut 0 ou 2 suivant $026A
			; viter les variables 0 et 2
ptr			equ $42	; variable initialise, ne pas bouger
alien_freq		equ $44	; variable initialise, ne pas bouger
player_offset	equ $45	; variable initialise, ne pas bouger
dest			equ $46
collision_test	equ $48

next_column		equ $4A
wave_style		equ $4B
offset1		equ $4C
offset2		equ $4D
timer			equ $4E
bullet_queue	equ $4F
ptr_bullet		equ $50
power			equ $52
alien_counter	equ $53
ptr_big		equ $54
seek_column_counter	equ $56
aux_counter		equ $57
big_alien_counter	equ $58
big_alien_column	equ $59
bullet_column	equ $5A
next_line		equ $5B
ptr_big_shape	equ $5C
savex			equ $5E
dont_use		equ $5F
ptr_aliens		equ $60	; 80 pointeurs


init
	sei				; vite que la routine clavier soit interrompue par le scan clavier normal
					; et amliore aussi les performances
	lda #$0A
	sta $026A
	lda #0
	sta $02E2			; le paramtre n'est pas automatiquement  0
	sta INK_COLOR
	sta PAPER_COLOR
	beq new_game

game_over
	ldx #GAME_OVER_MSG-1
	ldy #GAME_OVER_OFFSET-1
	jsr print_msg
wait_start
	ldx #$FE			; scanne colonne 0 (SPACE par exemple)
	jsr KBD_COL_SCAN
	beq wait_start

new_game
	jsr HIRES
	ldy #64		; d'abord 64 lignes en vert
	lda #2		; GREEN INK
	sta $0201		; et nb d'octets en largeur
	jsr fill2
	ldy #128		; puis 128 en jaune
	lda #3
	jsr fill2
	ldy #8		; puis 8 en rouge
	lda #1
	jsr fill2
	
	jsr blue_paper

	ldx #SCORE_MSG-1
	ldy #SCORE_OFFSET-1
	jsr print_msg	; renvoie A=0
	tax
	tay

zero_loop
	sta 0,x
	inx
	bne zero_loop
init_loop
	lda initial_values,x
	sta ptr,x
	inx
	cpx #4
	bne init_loop
	lda #$82		; Y=0 et X=4 (5 pages  initialiser)
init_columns
	iny
	sta (ptr),y
	iny
	bne init_columns
	inc ptr+1
	dex
	bpl init_columns

new_live
	lda lives
	cmp #'0'
	beq game_over

fill_power
	ldy #38
	sty $0D
	lda #$10	; paper BLACK
	jsr $F22D
	inc $0D
	lda #$7F	; pattern 111111
	jsr $F22D

	lda #LOW $A027
	sta $10
	lda #HIGH $A027
	sta $11
	lda #200
	sta power

main_loop
	lsr a
	bcc	main_loop1
						; met  jour le joueur une fois sur 4:
	jsr update_player
	lda big_alien_shape+3*6+1	; bouge les mandibules aussi  cette frquence
	eor #$61 XOR $73
	sta big_alien_shape+3*6+1

main_loop1
	jsr update_big_alien	; et le big alien une fois sur 2

main_loop2
	jsr update_bullet
	lda ptr_shape			; anime les aliens  chaque fois
	eor #LOW ((shape_def-1) XOR (shape_def2-1))
	sta ptr_shape
	jsr update_aliens

	inc timer
	lda timer
	lsr a
	bcs main_loop	; met  jour big alien une fois sur 2

	and alien_freq
	bne main_loop2
					; gnre un alien  la priode alien_freq+1
	inc alien_counter
	bne test_big_alien
					; change de style de vague tous les 256 aliens
	inc wave
	lda wave_style
	eor #$80
	sta wave_style
	bne test_big_alien
	sta seek_column_counter
	lsr alien_freq		; et diminue la priode de gnration une vague sur deux
test_big_alien
	lda alien_counter
	and #$3F
	bne create_small_alien
					; un big alien tous les 64 petits
	inc big_alien_counter
	lda big_alien_counter
	and #3
	tax
	lda big_columns,x
	sta big_alien_column
	sta ptr_big
	lda #HIGH TOP_LINE_ADDR
	sta ptr_big+1 
create_small_alien
	lda next_column
	asl a
	asl a
	asl a
	asl a
	tax
	ldy #QUEUE_SIZE
find_free
	lda ptr_aliens+1,x
	beq found_free
	inx
	inx
	dey
	bne find_free
	beq compute_next_column		; pas de place dans la file, abandonne la gnration
found_free
	ldy next_column
	lda columns,y
	sta ptr_aliens,x
	lda #HIGH TOP_LINE_ADDR
	sta ptr_aliens+1,x
compute_next_column
	inc seek_column_counter
	lda seek_column_counter
	bit wave_style
	bpl normal_wave
random_wave
	tax
	lda RANDOM_SEQUENCE,x
modulo
	sbc #NB_QUEUES
	cmp #NB_QUEUES
	bcs modulo
normal_wave
	cmp #NB_QUEUES
	bcc set_next_column
	lda #2*(NB_QUEUES-1)
	sbc seek_column_counter
	bne set_next_column
	sta seek_column_counter
set_next_column
	sta next_column
	jmp main_loop2
;***************************************************
; datas

initial_values

	dw $A618		; pour construction du dcor
	db $0F		; alien_freq
	db 18			; player_offset

messages

game_over_msg
	db $0C,$01
	string "GAME OVER"
	db 0
GAME_OVER_MSG	equ 0

score_msg
	db $03
	string "LIVES 3  SCORE 000000  WAVE 1"
	db 0
SCORE_MSG		equ score_msg-messages


; splatch_number  0,  1, 2, 3 , 4 , 5
splatch_offset1	db 37,82,118,161,199
splatch_offset2	db 43,78,122,159,201


columns		db 8,10,12,14,16,  22,24,26,28,30
big_columns		db 4,18,32,18

shape_def		db $44,$44,$65,$7F,$4E,$75,$6A
shape_def2		db $48,$48,$69,$7F,$5C,$6B,$55

big_shapes
player_shape
			db $40,$48,$40
			db $40,$48,$40
			db $5C,$5C,$5C
			db $76,$6A,$76
			db $63,$7F,$62
			db $76,$76,$76
			db $7C,$40,$5E

big_alien_shape
			db $41,$7F,$60
			db $47,$40,$78
			db $4D,$7F,$6C
			db $52,$7F,$52
			db $52,$52,$52
			db $64,$61,$49
			db $64,$61,$49


;***************************************************
; update des positions:

; les invaders en descente descendent d'un pixel par update:
; -> vitesse fixe 50 pixels/s
; ou deux pixels par update dans la partie infrieure de l'cran

; formation d'un invader au centre suprieur de l'cran
; (dans une porte des toiles faon Stargate)
; puis dplacement horizontal jusqu' la verticale du puits
; de rangement...
;
;.... ou N portes des toiles  la verticale des puits de rangement
; => uniquement des dplacements verticaux

; option : animation des portes des toiles:
; deux couronnes concentriques qui tournent, apparition d'un alien
; quand les repres sont aligns
; vitesse fixe de rotation et inversion de rotation lors de l'alignement
; de la porte la plus  gauche (et la plus  droite)
; -> squence d'alignement en balayage de gauche  droite puis de droite  gauche
; (les portes extrmes n'ont pas le temps de s'aligner pendant le balayage,
; et elles repartent dans l'autre sens quand la porte oppose s'ouvre)
;
; ide: couronnes incompltes, ouvertes toutes les deux vers le bas pour
; l'apparition d'un alien (=> permet de tirer jusque dans la porte au bon
; moment)

; + trois grosses portes des toiles pour les vaisseaux amiraux
; ncessitent l'alignement de trois couronnes concentriques

; dcalage dans les bobines de chargement lectrostatiques:
; les aliens descendent normalement dans les bobines pour s'accumuler en bas
; de la bobine (ils s'arrtent donc quand un autre alien est prsent dessous)

; Si la bobine est dj pleine, l'alien qui rentre en haut fait sortir celui
; du bas, et tous les autres descendent. La bobine descend aussi quand un alien
; est limin au bas de la bobine.
; => n'importe quel alien descend toujours, sauf si il y a un autre alien dessous
; et sauf s'il est au bas de la bobine (on force sa descente lorsqu'un alien tente
; de rentrer dans une bobine pleine)
; => l'update des positions des aliens doit se faire dans l'ordre de cration des
; aliens (les aliens les plus bas d'abord)
; => files de pointeurs en page zro, une par colonne d'aliens
; Ex: 8 colonnes avec pour chacune 7 aliens max par colonne (1 dans la porte,
; 4 dans la bobine, 2 en descente) = 56 pointeurs
;
; => il suffit de parcourir les 56 pointeurs dans l'ordre, avec un adressage index X
; Pour chaque pointeur, on le recopie dans un pointeur intermdiaire, on utilise alors
; l'adressage indirect index par Y pour faire les oprations graphiques
; 
;halt	db 2			; DEBUG

update_aliens
	ldx #0
	stx collision_test
alien_loop
	clc
alien_descent	; entre: X pointeur alien, Carry=1 : force descente
	stx savex
	; rcupration du pointeur d'alien
	lda ptr_aliens,x
	sta ptr
	ldy ptr_aliens+1,x
	sty ptr+1
	beq no_alien
	bcs force_move
; cpy #HIGH TOP_LINE_ADDR		; DEBUG
; bcc halt
	cpy #HIGH BOBINE_LAST_ADDR
	beq refresh
	;
	; teste si un alien est dessous
	iny
	clc
	adc #LOW 320
	bcc *+3
	 iny
	cmp ptr_aliens-2,x
	bne descent_ok
	tya
	cmp ptr_aliens-1,x
	bne descent_ok
	; il y a un alien dessous, on ne bouge plus si on n'est pas en haut de la bobine
	ldy ptr+1
	cpy #HIGH BOBINE_FIRST_ADDR
	bne next_alien
	; si on est en haut de la bobine, il y a forcment 4 aliens dessous, on les descend
	txa
	sbc #2*4		; Carry=1 forcment
	tax
	bcs alien_descent	; force la descente du 4e alien dessous
force_move
descent_ok
	;
	lda ptr
	ldy ptr+1
	clc
	adc #40
	bcc refresh
	iny
	;
refresh
	sta dest
	sta ptr_aliens,x	; mise  jour pointeur alien
	sty dest+1
	sty ptr_aliens+1,x
	cpy #HIGH BOTTOM_LINE_ADDR
	beq splatch
display_full_alien
	ldy #240
	ldx #7
display_alien
	lda (dest),y
	pha
	sec
move_loop
ptr_shape	equ *+1
	lda shape_def-1,x
	sta (dest),y
	tya
	sbc #40
	tay
	dex
	bne move_loop
	lda #PATTERN_VIDE
	sta (ptr,x)
	pla
	and #$3F-8			; -8 vite dtection projectile
	beq test_splatch
	lda dest+1
	cmp #HIGH NEAR_BOTTOM_LINE
	beq player_hit
test_splatch
	lda collision_test
	bne player_hit
next_alien
	ldx savex
	inx
	inx
	cpx #MAX_ALIENS*2
	bne alien_loop
return
	rts

no_alien				; compensation de vitesse
	ldy #30
	dey
	bne *-1
	beq next_alien

splatch			; C=1 
	ldx #6
compute_splatch_number
	dex
	beq clear_splatch
	sbc #40
	bcs compute_splatch_number
	ldy splatch_offset2-1,x
	lda #$38
	jsr test_and_fill_part
	ldy splatch_offset1-1,x
	lda #7
	jsr test_and_fill_part
	tya
	adc splatch_offset2-1,x	; peu importe la valeur prcdente de carry
	ror a					; calcule la valeur mdiane
	tay
	bne display_alien		; inconditionnel

update_big_alien
	lda ptr_big+1
	bpl return
	cmp #HIGH BOTTOM_LINE_ADDR
	beq big_alien_at_bottom
	jsr clear_big_alien
	lda ptr_big
	ldy ptr_big+1
	clc
	adc #40
	bcc *+3
	 iny
	sta ptr_big
	sty ptr_big+1
	sty ptr+1
	ldy #LOW big_alien_shape
	ldx #HIGH big_alien_shape
	jsr display_big_shape
	lda ptr_big+1			; DEBUG :  enlever quand le big alien ne traversera plus
	cmp #HIGH NEAR_BOTTOM_LINE	; le dcor
	bcc return
	lda collision_test
	and #$3F-8				; vite dtection du projectile
	beq return
big_alien_at_bottom
player_hit
;	pla			; OPTIMIZED: laisse une rcursivit malheureuse pour gagner de la place
;	pla
	dec lives
	jsr EXPLODE		; en sortie, Y vaut 14
	sty aux_counter
flash_loop
	lda #5
	jsr paper
	jsr blue_paper
	dec aux_counter
	bne flash_loop

	jsr clear_player
	jsr remove_big

quick_descent_loop
	jsr update_bullet
	jsr update_aliens	
	dec aux_counter
	bne quick_descent_loop
	jmp new_live

clear_splatch
	ldy #37
clear_loop
	lda #PATTERN_VIDE
	sta (ptr),y
	iny
	cpy #44
	bne clear_loop
	sta (ptr,x)			; X vaut 0
	sta ($10,x)			; efface une barre de power
	jsr SHOOT
	ldx savex
	jsr remove_alien
	jsr $F089			; +40 sur pointeur $10
	dec power
	beq player_hit
	jmp alien_loop		; pour traiter l'alien qui vient d'tre dcal

;***************************************************
bullet_miss
	sty ptr_bullet+1
	rts

update_bullet
	lda ptr_bullet+1
	bpl update_bullet_ok
	lda #PATTERN_VIDE
	jsr clear_bullet
forward_bullet
	lda ptr_bullet
	sec
	sbc #160
	sta ptr_bullet
	bcs display_bullet
	dec ptr_bullet+1
	lda ptr_bullet+1
	cmp #HIGH TOP_LINE_ADDR
	bcc bullet_miss
display_bullet
	lda (ptr_bullet),y
	cmp #PATTERN_VIDE
	bne hit_something
	lda #PATTERN_BULLET
clear_bullet
	ldy #40
	sta (ptr_bullet),y
	ldy #0
	sta (ptr_bullet),y
update_bullet_ok
	rts
hit_wall_or_big
	lda ptr_big+1
	bpl hit_wall
	lda bullet_column
	sec
	sbc big_alien_column
	bcc hit_wall
	cmp #3
	bcs hit_wall
big_hit
	ldy #4
	jsr increment_score
remove_big
	jsr clear_big_alien
	lsr ptr_big+1
hit_wall
	rts
hit_something
	sty ptr_bullet+1
	jsr KEY_CLICK2
	lda bullet_queue
	bmi hit_wall_or_big
					; c'est forcment le premier alien de la file
	asl a
	asl a
	asl a
	asl a
	tax
	lda ptr_aliens,x
	sta ptr
	lda ptr_aliens+1,x
	sta ptr+1

	ldy #5
	jsr increment_score
	sec
	ldy #240
clear_alien_loop
	lda #PATTERN_VIDE
	sta (ptr),y
	tya
	sbc #40
	tay
	bcs clear_alien_loop
remove_alien		; entre: X ptr alien dtruit: c'est forcment le premier d'une file
	ldy #QUEUE_SIZE*2-2
; and #$0F				; DEBUG
; beq shift_queue_loop
; db 2
shift_queue_loop
	lda ptr_aliens+2,x
	sta ptr_aliens,x
	inx
	dey
	bne shift_queue_loop
	sty ptr_aliens+1,x
no_bullet
	rts

;***************************************************
update_player
	jsr clear_player
	dec ptr+1			; ptr+1 a t incrment

	ldx #$FE			; scanne colonne 0
	jsr KBD_COL_SCAN
	beq test_right

	lda ptr_bullet+1	
	bne test_right		; dj un tir en cours
	ldy player_offset
	iny
	sty ptr_bullet
	sty bullet_column
	lda #HIGH BOTTOM_LINE_ADDR
	sta ptr_bullet+1
	tya
	ldx #NB_QUEUES-1
find_queue
	cmp columns,x
	beq alien_above
	dex
	bpl find_queue
alien_above
	stx bullet_queue

test_right
	ldx #$7F			; scanne colonne 7
	jsr KBD_COL_SCAN
	bne go_right
	ldx #$DF			; scanne colonne 5
	jsr KBD_COL_SCAN
	beq no_key
go_left
	ldy player_offset
	cpy #2
	beq display_player
	dey
	bne display_player
go_right
	ldy player_offset
	cpy #34
	beq display_player
	iny
display_player
	sty player_offset
no_key
	lda player_offset
	ldy #LOW player_shape
	ldx #HIGH player_shape
	bne display_big_shape

clear_player
	lda #HIGH BOTTOM_LINE_ADDR
	sta ptr+1
	lda player_offset
	bne clear_big_shape
clear_big_alien
	lda ptr_big+1
	bpl return2
	sta ptr+1
	lda ptr_big
clear_big_shape		; entre: A poids faible de l'adr, ptr+1 dj initialis
	ldy #LOW $BF28
	ldx #HIGH $BF28
display_big_shape
	sta ptr
	sty ptr_big_shape
	stx ptr_big_shape+1
	ldy #0
display_big_shape_loop
	lda (ptr),y
	pha
	lda (ptr_big_shape),y
	sta (ptr),y
	iny
	lda (ptr_big_shape),y
	sta (ptr),y
	iny
	pla
	ora (ptr),y
	sta collision_test
	lda (ptr_big_shape),y
	sta (ptr),y
	clc
	lda ptr
	adc #37
	sta ptr
	bcc *+4
	 inc ptr+1
	iny
	cpy #21
	bne display_big_shape_loop
return2
	rts


;***************************************************

blue_paper
	lda #4
paper	sta $02E1
	jmp $F204
;yellow_ink
;	lda #3
;ink	sta $02E1
;	jmp $F210


fill2	
	sta $0202		; valeur de remplissage
	sty $0200		; hauteur
	jmp $F2CD

test_and_fill_part
	pha
	and (dest),y
	ora collision_test
	sta collision_test
	pla
	ora (dest),y
	sta (dest),y
	rts

propagate_carry
	lda #$30
	sta score,y
	dey
increment_score
	lda score,y
	cmp #$39
	bcs propagate_carry
	adc #1
	sta score,y
	rts

print_msg
	inx
	iny
	lda messages,x
	sta TEXT_LINES,y
	bne print_msg
	rts
	
